clc;
clear
close all;

% Load raw campaign file
load('Campaign_data_NBIoT_1_2_3_4_5_6.mat');

% Find unique NPCIs (<NPCI, eNodeB-ID, MNC> triplets)
NPCI = cell2mat(dataSet(:,3));
NPCI = unique(NPCI(:,[1,2,8]),'rows');

% Create a copy of the dataset
dataSet_interp= dataSet;

for j = 1:size(NPCI,1)
    targetNPCI = NPCI(j,:);

    % Find all entries for the considered unique NPCI
    tmp = [];
    for i = 1:size(dataSet,1)
        thisMatrix = dataSet{i,3};
        for k = 1:size(thisMatrix,1)
            if thisMatrix(k,[1,2,8]) == targetNPCI
                tmp = [tmp; [i, k, thisMatrix(k,3:6)]];
            end
        end
    end
    % tmp is a temporary matrix storing in each row:
    % - first column, the index of the data point where the unique NPCI was
    % detected
    % - second column, the index of the row in the RF data matrix that contains the unique NPCI data at the data point 
    % - third column, the RSSI value
    % - fourth column, the SINR value
    % - fifth column, the RSRP value
    % - sixth column, the RSRQ value
    
    tmp_interp = tmp;
    % we create an interpolated version of the same data stored in tmp
    for i = 3:6
        tmp_interp(:,i) = fillmissing(tmp(:,i),'linear');
    end

    % we store the interpolated data in the dataset
    for i = 1:size(tmp,1)
        dataSet_interp{tmp(i,1),3}(tmp(i,2),3:6) = tmp_interp(i,3:6);
    end
end
dataSet=dataSet_interp;
save('Campaign_data_NBIoT_1_2_3_4_5_6_Interpolated.mat');